; =============================================================================
; Name: CRT12CO.S
; Func: ICC12V6 Startup Module for
;       HC12compact Single Board Computer in Expanded Wide Mode
; Copr: Imagecraft Inc., additions by MCT/Oliver Thamm
; Vers: 1.2
; =============================================================================
;
; Do not define any .area above this line. .text must be the first
; line in this file.  You may put .area(s) at the end of the file.
;

	.include "hc12.i"

; You need to define this symbol on the link command line:
;	init_sp		: initial stack pointer
; The entry point of your program is _start, which is defined here.
;
	.area text
__start::				; entry point
	;
	; Critical MCU settings first
	; REM: MCU starts in NormExpMode
	;
	clr  COPCTL			; Disable Watchdog
	movb #$0c,PEAR		; LSTRE+RDWE, ECLK
	movb #$3F,CSCTL0	; Enable CSP0+CSD+CS3+CS2+CS1+CS0
	movb #$10,CSCTL1	; CSD covers $0000-$7fff
	movb #$30,CSSTR0	; CSP0+CSD not stretched (CSP1:3x)
	movb #$FF,CSSTR1	; CS0..3 stretched (3x)
	movb #$fe,PPAGE		; Program Page $FE
	movb #$c0,WINDEF	; DWEN+PWEN
	movb #$0f,MXAR		; A16E...A19E
	movb #$80,DDRE		; PE7=Out (LED driver)
	movb #$00,PORTE		; LED on
	;
	; Optional (if you want to protect the EEPROM array):
	;
	movb #$ff,EEPROT	; Protect EEPROM
	movb #$fe,EEMCR		; Lock protection
	;
	lds	#init_sp		; now we have access to the ext. RAM too...
	;
	jsr	__HC12Setup		; define your own setup rtn if you want to do
						; initialization stuff before main()
; clear BSS
	clra
	ldx	#__bss_start
init_loop:
	cpx	#__bss_end
	beq	init_done
	staa	0,x
	inx
	bra	init_loop

init_done:
; copy initialized idata to data
	ldx	#__idata_start
	ldy	#__data_start
copy_loop:
	cpx	#__idata_end
	beq copy_done
	movb 1,x+,1,y+
	bra copy_loop
copy_done:

; call user main routine
	jsr _main
_exit::
	bra	_exit

    ; __idata_start MUST follow text area for it to be in ROM
	.area idata
__idata_start::

	.area data
__data_start::

	.area bss
__bss_start::
